pro create_netCDF_ForNCDC

Path_in='/volumes/Data_Karma/birgit/BDBP_Tiers/'
Vert_idx='ALT'
Year='2015'
Month='01'
Day='23'
Time=strmid(systime(0),11,8)
creation_string=Year+Month+Day+'T'+Time+'Z'
if (Vert_idx eq 'ALT') then $
  Vert_string='altitude' $
else $
  Vert_string='pressurelevel'


; altitude
; read in the different files
Tier0_ND=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-ND-'+Vert_idx+'_Tier0_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_1_ND=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-ND-'+Vert_idx+'_Tier1_1_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_2_ND=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-ND-'+Vert_idx+'_Tier1_2_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_3_ND=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-ND-'+Vert_idx+'_Tier1_3_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_4_ND=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-ND-'+Vert_idx+'_Tier1_4_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier0_MR=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-MR-'+Vert_idx+'_Tier0_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_1_MR=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-MR-'+Vert_idx+'_Tier1_1_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_2_MR=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-MR-'+Vert_idx+'_Tier1_2_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_3_MR=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-MR-'+Vert_idx+'_Tier1_3_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
Tier1_4_MR=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-MR-'+Vert_idx+'_Tier1_4_T2Mz_O3.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                     /PRINT_TAGS)
                            

; exchange the fill values (1.0e+20) with -999.99
; ND
Tier0_ND_idx=where(Tier0_ND.O3 gt 1.0e+19,cnt_Tier0_ND)
if (cnt_Tier0_ND gt 0) then begin
  Tier0_ND.O3[Tier0_ND_idx]=-999.99
endif
Tier1_1_ND_idx=where(Tier1_1_ND.O3 gt 1.0e+19,cnt_Tier1_1_ND)
if (cnt_Tier1_1_ND gt 0) then begin
  Tier1_1_ND.O3[Tier1_1_ND_idx]=-999.99
endif
Tier1_2_ND_idx=where(Tier1_2_ND.O3 gt 1.0e+19,cnt_Tier1_2_ND)
if (cnt_Tier1_2_ND gt 0) then begin
  Tier1_2_ND.O3[Tier1_2_ND_idx]=-999.99
endif
Tier1_3_ND_idx=where(Tier1_3_ND.O3 gt 1.0e+19,cnt_Tier1_3_ND)
if (cnt_Tier1_3_ND gt 0) then begin
  Tier1_3_ND.O3[Tier1_3_ND_idx]=-999.99
endif
Tier1_4_ND_idx=where(Tier1_4_ND.O3 gt 1.0e+19,cnt_Tier1_4_ND)
if (cnt_Tier1_4_ND gt 0) then begin
  Tier1_4_ND.O3[Tier1_4_ND_idx]=-999.99
endif
; MR
Tier0_MR_idx=where(Tier0_MR.O3 gt 1.0e+19,cnt_Tier0_MR)
if (cnt_Tier0_MR gt 0) then begin
  Tier0_MR.O3[Tier0_MR_idx]=-999.99
endif
Tier1_1_MR_idx=where(Tier1_1_MR.O3 gt 1.0e+19,cnt_Tier1_1_MR)
if (cnt_Tier1_1_MR gt 0) then begin
  Tier1_1_MR.O3[Tier1_1_MR_idx]=-999.99
endif
Tier1_2_MR_idx=where(Tier1_2_MR.O3 gt 1.0e+19,cnt_Tier1_2_MR)
if (cnt_Tier1_2_MR gt 0) then begin
  Tier1_2_MR.O3[Tier1_2_MR_idx]=-999.99
endif
Tier1_3_MR_idx=where(Tier1_3_MR.O3 gt 1.0e+19,cnt_Tier1_3_MR)
if (cnt_Tier1_3_MR gt 0) then begin
  Tier1_3_MR.O3[Tier1_3_MR_idx]=-999.99
endif
Tier1_4_MR_idx=where(Tier1_4_MR.O3 gt 1.0e+19,cnt_Tier1_4_MR)
if (cnt_Tier1_4_MR gt 0) then begin
  Tier1_4_MR.O3[Tier1_4_MR_idx]=-999.99
endif


; define and fill the 'lat_bnds' and 'time_bnds' variable
lat_bounds=fltarr(36,2)
time_bounds=fltarr(348,2)
time_adj=fltarr(348)
for I=0,n_elements(Tier1_1_ND.lat)-1 do begin
  lat_bounds[I,0]=Tier1_1_ND.lat[I]-2.5
  lat_bounds[I,1]=Tier1_1_ND.lat[I]+2.5  
endfor

year_cnt=1979
month_cnt=1
for I=0,n_elements(Tier1_1_ND.time)-1 do begin
  time_adj[I]=Tier1_1_ND.time[I]+0.5
  base_date=julday(1,1,1950)                    ; since everything is counted from 1.1.1950
  time_bounds[I,0]=(julday(month_cnt,1,year_cnt))-base_date
  if (month_cnt lt 12) then begin
    time_bounds[I,1]=(julday(month_cnt+1,1,year_cnt))-base_date
  endif else begin
    time_bounds[I,1]=(julday(month_cnt,31,year_cnt)+1)-base_date
  endelse
  month_cnt++
  if (month_cnt eq 13) then begin
    month_cnt=1
    year_cnt++
  endif
endfor


;output_file=Path_in+'CCMVal2_REF-B1_BSOzone-'+vert_idx+'_T2Mz_O3_ncdf4.nc'
output_file=Path_in+'Ozone-ESRL-CDR_v01r01_'+Vert_string+'_s19790707_e20140707_c20140808.nc


data=NCDF_CREATE(output_file, /CLOBBER,  /NETCDF4_FORMAT)
dim_t=NCDF_DIMDEF(data,'time',348)
dim_z=NCDF_DIMDEF(data,'z',70)
dim_y=NCDF_DIMDEF(data,'lat',36)
dim_x=NCDF_DIMDEF(data,'nv',2)
var_time=NCDF_VARDEF(data,'time',dim_t,/FLOAT)
var_lat=NCDF_VARDEF(data,'lat',dim_y,/FLOAT)
if (Vert_idx eq 'ALT') then begin
  var_alt=NCDF_VARDEF(data,'z',dim_z,/FLOAT)
endif else begin
  var_alt=NCDF_VARDEF(data,'z',dim_z,/FLOAT)
endelse
var_timebnd=NCDF_VARDEF(data,'time_bnds',[dim_x,dim_t],/FLOAT)
var_latbnd=NCDF_VARDEF(data,'lat_bnds',[dim_x,dim_y],/FLOAT)
;var_latbnd=NCDF_VARDEF(data,'z_bnds',[dim_x,dim_z],/FLOAT)
var_Tier0_ND=NCDF_VARDEF(data,'Number_Concentration_of_Ozone_of_raw_monthly_means_Tier_0',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_1_ND=NCDF_VARDEF(data,'Number_Concentration_of_Ozone_of_monthly_means_representing_Anthropogenic_Influences_Tier1_1',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_2_ND=NCDF_VARDEF(data,'Number_Concentration_of_Ozone_of_monthly_means_representing_Natural_Influences_Tier1_2',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_3_ND=NCDF_VARDEF(data,'Number_Concentration_of_Ozone_of_monthly_means_representing_Natural_and_Volcanic_Influences_Tier1_3',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_4_ND=NCDF_VARDEF(data,'NOAA_Climate_Data_Record_of_Zonal_Mean_Ozone_in_Number_Concentration_Tier1_4',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier0_MR=NCDF_VARDEF(data,'Ozone_Mixing_Ratio_of_raw_monthly_means_Tier_0',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_1_MR=NCDF_VARDEF(data,'Ozone_Mixing_Ratio_of_monthly_means_representing_Anthropogenic_Influences_Tier1_1',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_2_MR=NCDF_VARDEF(data,'Ozone_Mixing_Ratio_of_monthly_means_representing_Natural_Influences_Tier1_2',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_3_MR=NCDF_VARDEF(data,'Ozone_Mixing_Ratio_of_monthly_means_representing_Natural_and_Volcanic_Influences_Tier1_3',[dim_y,dim_z,dim_t],/FLOAT)
var_Tier1_4_MR=NCDF_VARDEF(data,'NOAA_Climate_Data_Record_of_Zonal_Mean_Ozone_in_Mixing_Ratio_Tier1_4',[dim_y,dim_z,dim_t],/FLOAT)

; attributes for the time axis
NCDF_ATTPUT, data, var_time, 'units', 'days since 1950-01-01 00:00:00', /char
NCDF_ATTPUT, data, var_time, 'long_name', 'time', /char
NCDF_ATTPUT, data, var_time, 'standard_name', 'time', /char
NCDF_ATTPUT, data, var_time, 'calendar', 'gregorian', /char
NCDF_ATTPUT, data, var_time, 'axis', 'T', /char
NCDF_ATTPUT, data, var_time, 'bounds','time_bnds', /char

; attributes for the lat axis
NCDF_ATTPUT, data, var_lat, 'units', 'degrees_north', /char
NCDF_ATTPUT, data, var_lat, 'long_name', 'Latitude', /char
NCDF_ATTPUT, data, var_lat, 'standard_name', 'latitude', /char
NCDF_ATTPUT, data, var_lat, 'axis', 'Y', /char
NCDF_ATTPUT, data, var_lat, 'bounds','lat_bnds', /char

;; attributes for the lat axis
;NCDF_ATTPUT, data, var_lat, 'units', 'degrees_north'
;NCDF_ATTPUT, data, var_lat, 'long_name', 'Latitude'
;NCDF_ATTPUT, data, var_lat, 'standard_name', 'latitude'
;NCDF_ATTPUT, data, var_lat, 'axis', 'Y'

; attributes for the alt axis
; Alt
if (vert_idx eq 'ALT') then begin
  NCDF_ATTPUT, data, var_alt, 'units', 'km', /char
  NCDF_ATTPUT, data, var_alt, 'long_name', 'Altitude', /char
  NCDF_ATTPUT, data, var_alt, 'standard_name', 'altitude', /char
  NCDF_ATTPUT, data, var_alt, 'axis', 'Z', /char
endif
; Press
if (vert_idx eq 'PRS') then begin
  NCDF_ATTPUT, data, var_alt, 'units', 'hPa', /char
  NCDF_ATTPUT, data, var_alt, 'long_name', 'Pressure', /char
  NCDF_ATTPUT, data, var_alt, 'standard_name', 'air_pressure', /char
  NCDF_ATTPUT, data, var_alt, 'positive', 'down', /char
  NCDF_ATTPUT, data, var_alt, 'axis', 'Z', /char
endif


; define the common attributes for the Tiers
; MR
O3_unit_MR='mole mole^-1'
O3_standard_name_MR='mole_fraction_of_ozone_in_air'
O3_cell_method_MR_raw='z: point longitude: lat: time: mean (uncertainty weighted)'
O3_cell_method_MR='z: point longitude: lat: time: mean (selected components of multiple regression fit)'
O3_fillvalue_MR=-999.99

; ND
;O3_unit='10^18 molecules/m^3'
O3_unit_ND='examolecules/m^3'
;O3_SF_ND='10^18'
O3_standard_name_ND='number_concentration_of_ozone_molecules_in_air'
O3_cell_method_ND_raw='z: point longitude: lat: time: mean (uncertainty weighted)'
O3_cell_method_ND='z: point longitude: lat: time: mean (selected components of multiple regression fit)'
O3_fillvalue_ND=-999.99


; attributes for Tier0_ND
NCDF_ATTPUT, data, var_Tier0_ND, 'units', O3_unit_ND, /char
;NCDF_ATTPUT, data, var_Tier0_ND, 'scale_factor', O3_SF_ND
NCDF_ATTPUT, data, var_Tier0_ND, 'long_name', 'Number Concentration of Ozone of raw monthly means Tier 0', /char
NCDF_ATTPUT, data, var_Tier0_ND, 'standard_name', O3_standard_name_ND, /char
NCDF_ATTPUT, data, var_Tier0_ND, 'cell_methods', O3_cell_method_ND_raw, /char
NCDF_ATTPUT, data, var_Tier0_ND, '_FillValue', O3_fillvalue_ND

; attributes for Tier1_1_ND
NCDF_ATTPUT, data, var_Tier1_1_ND, 'units', O3_unit_ND, /char
;NCDF_ATTPUT, data, var_Tier1_1_ND, 'scale_factor', O3_SF_ND
NCDF_ATTPUT, data, var_Tier1_1_ND, 'long_name', 'Number Concentration of Ozone of monthly means representing Anthropogenic Influences Tier1_1', /char
NCDF_ATTPUT, data, var_Tier1_1_ND, 'standard_name', O3_standard_name_ND, /char
NCDF_ATTPUT, data, var_Tier1_1_ND, 'cell_methods', O3_cell_method_ND, /char
NCDF_ATTPUT, data, var_Tier1_1_ND, '_FillValue', O3_fillvalue_ND

; attributes for Tier1_2_ND
NCDF_ATTPUT, data, var_Tier1_2_ND, 'units', O3_unit_ND, /char
;NCDF_ATTPUT, data, var_Tier1_2_ND, 'scale_factor', O3_SF_ND
NCDF_ATTPUT, data, var_Tier1_2_ND, 'long_name', 'Number Concentration of Ozone of monthly means representing Natural Influences Tier1_2', /char
NCDF_ATTPUT, data, var_Tier1_2_ND, 'standard_name', O3_standard_name_ND, /char
NCDF_ATTPUT, data, var_Tier1_2_ND, 'cell_methods', O3_cell_method_ND, /char
NCDF_ATTPUT, data, var_Tier1_2_ND, '_FillValue', O3_fillvalue_ND

; attributes for Tier1_3_ND
NCDF_ATTPUT, data, var_Tier1_3_ND, 'units', O3_unit_ND, /char
;NCDF_ATTPUT, data, var_Tier1_3_ND, 'scale_factor', O3_SF_ND
NCDF_ATTPUT, data, var_Tier1_3_ND, 'long_name', 'Number Concentration of Ozone of monthly means representing Natural and Volcanic Influences Tier1_3', /char
NCDF_ATTPUT, data, var_Tier1_3_ND, 'standard_name', O3_standard_name_ND, /char
NCDF_ATTPUT, data, var_Tier1_3_ND, 'cell_methods', O3_cell_method_ND, /char
NCDF_ATTPUT, data, var_Tier1_3_ND, '_FillValue', O3_fillvalue_ND

; attributes for Tier1_4_ND
NCDF_ATTPUT, data, var_Tier1_4_ND, 'units', O3_unit_ND, /char
;NCDF_ATTPUT, data, var_Tier1_4_ND, 'scale_factor', O3_SF_ND
NCDF_ATTPUT, data, var_Tier1_4_ND, 'long_name', 'NOAA Climate Data Record of Zonal Mean Ozone in Number Concentration Tier1_4', /char
NCDF_ATTPUT, data, var_Tier1_4_ND, 'standard_name', O3_standard_name_ND, /char
NCDF_ATTPUT, data, var_Tier1_4_ND, 'cell_methods', O3_cell_method_ND, /char
NCDF_ATTPUT, data, var_Tier1_4_ND, '_FillValue', O3_fillvalue_ND

; attributes for Tier0_MR
NCDF_ATTPUT, data, var_Tier0_MR, 'units', O3_unit_MR, /char
NCDF_ATTPUT, data, var_Tier0_MR, 'long_name', 'Ozone Mixing Ratio of raw monthly means Tier 0', /char
NCDF_ATTPUT, data, var_Tier0_MR, 'standard_name', O3_standard_name_MR, /char
NCDF_ATTPUT, data, var_Tier0_MR, 'cell_methods', O3_cell_method_MR_raw, /char
NCDF_ATTPUT, data, var_Tier0_MR, '_FillValue', O3_fillvalue_MR

; attributes for Tier1_1_MR
NCDF_ATTPUT, data, var_Tier1_1_MR, 'units', O3_unit_MR, /char
NCDF_ATTPUT, data, var_Tier1_1_MR, 'long_name', 'Ozone Mixing Ratio of monthly means representing Anthropogenic Influences Tier1_1', /char
NCDF_ATTPUT, data, var_Tier1_1_MR, 'standard_name', O3_standard_name_MR, /char
NCDF_ATTPUT, data, var_Tier1_1_MR, 'cell_methods', O3_cell_method_MR, /char
NCDF_ATTPUT, data, var_Tier1_1_MR, '_FillValue', O3_fillvalue_MR

; attributes for Tier1_2_MR
NCDF_ATTPUT, data, var_Tier1_2_MR, 'units', O3_unit_MR, /char
NCDF_ATTPUT, data, var_Tier1_2_MR, 'long_name', 'Ozone Mixing Ratio of monthly means representing Natural Influences Tier1_2', /char
NCDF_ATTPUT, data, var_Tier1_2_MR, 'standard_name', O3_standard_name_MR, /char
NCDF_ATTPUT, data, var_Tier1_2_MR, 'cell_methods', O3_cell_method_MR, /char
NCDF_ATTPUT, data, var_Tier1_2_MR, '_FillValue', O3_fillvalue_MR

; attributes for Tier1_3_MR
NCDF_ATTPUT, data, var_Tier1_3_MR, 'units', O3_unit_MR, /char
NCDF_ATTPUT, data, var_Tier1_3_MR, 'long_name', 'Ozone Mixing Ratio of monthly means representing Natural and Volcanic Influences Tier1_3', /char
NCDF_ATTPUT, data, var_Tier1_3_MR, 'standard_name', O3_standard_name_MR, /char
NCDF_ATTPUT, data, var_Tier1_3_MR, 'cell_methods', O3_cell_method_MR, /char
NCDF_ATTPUT, data, var_Tier1_3_MR, '_FillValue', O3_fillvalue_MR

; attributes for Tier1_4_MR
NCDF_ATTPUT, data, var_Tier1_4_MR, 'units', O3_unit_MR, /char
NCDF_ATTPUT, data, var_Tier1_4_MR, 'long_name', 'NOAA Climate Data Record of Zonal Mean Ozone in Mixing Ratio Tier1_4', /char
NCDF_ATTPUT, data, var_Tier1_4_MR, 'standard_name', O3_standard_name_MR, /char
NCDF_ATTPUT, data, var_Tier1_4_MR, 'cell_methods', O3_cell_method_MR, /char
NCDF_ATTPUT, data, var_Tier1_4_MR, '_FillValue', O3_fillvalue_MR


; global attributes
NCDF_ATTPUT, data, /GLOBAL, 'title', 'NOAA Climate Data Record (CDR) of the Zonal Mean Ozone Binary Database of Profiles (BDBP)', /char
NCDF_ATTPUT, data, /GLOBAL, 'creator_name', 'Birgit Hassler', /char
NCDF_ATTPUT, data, /GLOBAL, 'creator_email', 'birgit.hassler@gmail.com', /char
NCDF_ATTPUT, data, /GLOBAL, 'contributor_name', 'Greg Bodeker', /char
NCDF_ATTPUT, data, /GLOBAL, 'contributor_email', 'greg@bodekerscientific.com', /char
NCDF_ATTPUT, data, /GLOBAL, 'contributor_name', 'Karen Rosenlof', /char
NCDF_ATTPUT, data, /GLOBAL, 'contributor_email', 'karen.h.rosenlof@noaa.gov', /char
NCDF_ATTPUT, data, /GLOBAL, 'software_version_id', '1.1.0.6', /char
NCDF_ATTPUT, data, /GLOBAL, 'product_version', 'v01r00', /char
NCDF_ATTPUT, data, /GLOBAL, 'source', 'BDBP database providing data from eight satellite instruments '+ $ 
                                      '(SAGE I, SAGE II, HALOE, POAM II, POAM III, ILAS, ILAS II, LIMS) and ozonesonde stations globally '+ $
                                      '(BDBP_database_auxdata); QBO '+ $
                                      '(qbo[1].dat); Solar flux data (10.7cm wavelength; '+ $
                                      'Solar_data); ENSO (soi.dat); First guess of regression '+ $
                                      'model fit coefficients (BodekerScientific_TCO_data)', /char
NCDF_ATTPUT, data, /GLOBAL, 'Conventions', 'CF-1.6', /char
NCDF_ATTPUT, data, /GLOBAL, 'Metadata_Conventions', 'CF-1.6, Unidata Dataset Discovery v1.0, NOAA CDR v1.0, GDS v2.0', /char
NCDF_ATTPUT, data, /GLOBAL, 'standard_name_vocabulary', 'CF Standard Name Table (v25, 05 July 2013)', /char
NCDF_ATTPUT, data, /GLOBAL, 'id', 'CCMVal2_REF-B1_BSOzone-'+vert_idx+'_T2Mz_O3_ncdf4.nc', /char
NCDF_ATTPUT, data, /GLOBAL, 'naming_authority', 'gov.noaa.ncdc', /char
NCDF_ATTPUT, data, /GLOBAL, 'metadata_link', 'gov.noaa.ncdc:C00930', /char
NCDF_ATTPUT, data, /GLOBAL, 'summary', 'The BDBP CDR is a global, gap-free, vertically resolved, zonal mean ozone data set that spans the period 1979-2007.', /char
NCDF_ATTPUT, data, /GLOBAL, 'keywords', 'EARTH SCIENCE, ATMOSPHERE, ATMOSPHERIC CHEMISTRY, OXYGEN COMPOUNDS, OZONE', /char
NCDF_ATTPUT, data, /GLOBAL, 'keywords_vocabulary', 'NASA Global Change Master Directory (GCMD) Earth Science Keywords, Version 8.0', /char
NCDF_ATTPUT, data, /GLOBAL, 'platform', 'Balloons/Rockets - BALLOONS, Earth Observation Satellites', /char
;NCDF_ATTPUT, data, /GLOBAL, 'featureType', 'Grid', /char
NCDF_ATTPUT, data, /GLOBAL, 'cdm_data_type', 'Grid', /char
NCDF_ATTPUT, data, /GLOBAL, 'cdr_program', 'Climate Data Record Program for satellites, FY 2014', /char
NCDF_ATTPUT, data, /GLOBAL, 'cdr_variable', 'NOAA Climate Data Record of Zonal Mean Ozone in Number Concentration Tier1_4, NOAA Climate Data Record of ' + $
                                            'Zonal Mean Ozone in Mixing Ratio Tier1_4', /char
NCDF_ATTPUT, data, /GLOBAL, 'date_created',  creation_string, /char
NCDF_ATTPUT, data, /GLOBAL, 'institution', 'NOAA, Earth System Research Laboratory, Chemical Sciences Division', /char
NCDF_ATTPUT, data, /GLOBAL, 'processing_level',  'NOAA Level 3', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lat_min', '-90.', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lat_max', '90.', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lon_min', '0.', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lon_max', '360.', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lat_units', 'degrees_north', /char
NCDF_ATTPUT, data, /GLOBAL, 'geospatial_lon_units', 'degrees_east', /char
NCDF_ATTPUT, data, /GLOBAL, 'spatial_resolution', 'zonal mean, 10 degree latitude bands', /char
NCDF_ATTPUT, data, /GLOBAL, 'time_coverage_start', '19790115T00:00:00Z', /char
NCDF_ATTPUT, data, /GLOBAL, 'time_coverage_end',  '20071215T00:00:00Z', /char
NCDF_ATTPUT, data, /GLOBAL, 'time_coverage_duration', 'P29Y', /char
NCDF_ATTPUT, data, /GLOBAL, 'time_resolution', 'P1M', /char
NCDF_ATTPUT, data, /GLOBAL, 'license', 'No restrictions on access or use', /char


NCDF_CONTROL, data, /ENDEF
if (vert_idx eq 'ALT') then begin
  NCDF_VARPUT, data, var_alt, Tier1_1_ND.alt
endif else begin
  NCDF_VARPUT, data, var_alt, Tier1_1_ND.plev
endelse
NCDF_VARPUT, data, var_lat, Tier1_1_ND.lat
NCDF_VARPUT, data, var_time, time_adj
NCDF_VARPUT, data, var_timebnd, transpose(time_bounds)
NCDF_VARPUT, data, var_latbnd, transpose(lat_bounds)
NCDF_VARPUT, data, var_Tier0_ND, Tier0_ND.O3
NCDF_VARPUT, data, var_Tier1_1_ND, Tier1_1_ND.O3
NCDF_VARPUT, data, var_Tier1_2_ND, Tier1_2_ND.O3
NCDF_VARPUT, data, var_Tier1_3_ND, Tier1_3_ND.O3
NCDF_VARPUT, data, var_Tier1_4_ND, Tier1_4_ND.O3
NCDF_VARPUT, data, var_Tier0_MR, Tier0_MR.O3
NCDF_VARPUT, data, var_Tier1_1_MR, Tier1_1_MR.O3
NCDF_VARPUT, data, var_Tier1_2_MR, Tier1_2_MR.O3
NCDF_VARPUT, data, var_Tier1_3_MR, Tier1_3_MR.O3
NCDF_VARPUT, data, var_Tier1_4_MR, Tier1_4_MR.O3
NCDF_CLOSE, data


; read in the different files
Tier_all=ncdf_to_struct('CCMVal2_REF-B1_BSOzone-'+vert_idx+'_T2Mz_O3_ncdf4.nc', DIREC='/volumes/Data_Karma/birgit/BDBP_Tiers/', $
                        /PRINT_TAGS, /PRINT_GLOBAL_ATTRIBUTES, /PRINT_VAR_ATTRIBUTES)

help, Tier_all

;The following IDL commands should be used to create a new netCDF file:
;NCDF_CREATE: Call this procedure to begin creating a new file. The new file is put into define mode.
;NCDF_DIMDEF: Create dimensions for the file.
;NCDF_VARDEF: Define the variables to be used in the file.
;NCDF_ATTPUT: Optionally, use attributes to describe the data.
;NCDF_CONTROL, /ENDEF: Call NCDF_CONTROL and set the ENDEF keyword to leave define mode and enter data mode.
;NCDF_VARPUT: Write the appropriate data to the netCDF file.
;NCDF_CLOSE: Close the file.

;TCO_Mean79to81={time:fltarr(12), lat:fltarr(36), lon:fltarr(12), TCO:fltarr(36,12,12)}
;TCO_Mean95to97={time:fltarr(12), lat:fltarr(36), lon:fltarr(12), TCO:fltarr(36,12,12)}
;TCO_Mean79to81_highres={time:fltarr(12), lat:fltarr(72), lon:fltarr(144), TCO:fltarr(72,144,12)}
;TCO_Mean95to97_highres={time:fltarr(12), lat:fltarr(72), lon:fltarr(144), TCO:fltarr(72,144,12)}



;if (Save_file eq 'yes') then begin
;  ; based on the MONTHLY TCO data!!!
;  ; now create the netCDF-file
;  output_file='/volumes/Data_Thor/birgit/TCO_BS/Mean_TCO_BS_79to81.nc'
;  data=NCDF_CREATE(output_file, /CLOBBER)
;  dim_x=NCDF_DIMDEF(data,'x',36)
;  dim_y=NCDF_DIMDEF(data,'y',12)
;  dim_z=NCDF_DIMDEF(data,'z',12)
;  var_time=NCDF_VARDEF(data,'time',dim_z,/FLOAT)
;  var_lat=NCDF_VARDEF(data,'lat',dim_x,/FLOAT)
;  var_lon=NCDF_VARDEF(data,'lon',dim_y,/FLOAT)
;  var_tco=NCDF_VARDEF(data,'TCO',[dim_x,dim_y,dim_z],/FLOAT)
;  NCDF_CONTROL, data, /ENDEF
;  NCDF_VARPUT, data, var_lat, lat_array
;  NCDF_VARPUT, data, var_lon, lon_array
;  NCDF_VARPUT, data, var_time, time
;  NCDF_VARPUT, data, var_tco, TCO_mean79to81_Array
;  NCDF_CLOSE, data

;  output_file='/volumes/Data_Thor/birgit/TCO_BS/Mean_TCO_BS_95to97.nc'
;  data=NCDF_CREATE(output_file, /CLOBBER)
;  dim_x=NCDF_DIMDEF(data,'x',36)
;  dim_y=NCDF_DIMDEF(data,'y',12)
;  dim_z=NCDF_DIMDEF(data,'z',12)
;  var_time=NCDF_VARDEF(data,'time',dim_z,/FLOAT)
;  var_lat=NCDF_VARDEF(data,'lat',dim_x,/FLOAT)
;  var_lon=NCDF_VARDEF(data,'lon',dim_y,/FLOAT)
;  var_tco=NCDF_VARDEF(data,'TCO',[dim_x,dim_y,dim_z],/FLOAT)
;  NCDF_CONTROL, data, /ENDEF
;  NCDF_VARPUT, data, var_lat, lat_array
;  NCDF_VARPUT, data, var_lon, lon_array
;  NCDF_VARPUT, data, var_time, time
;  NCDF_VARPUT, data, var_tco, TCO_mean95to97_Array
;  NCDF_CLOSE, data

;  ; based on the DAILY TCO data!!!
;  output_file='/volumes/Data_Thor/birgit/TCO_BS/Mean_TCO_BS_79to81_highres.nc'
;  data=NCDF_CREATE(output_file, /CLOBBER)
;  dim_x=NCDF_DIMDEF(data,'x',72)
;  dim_y=NCDF_DIMDEF(data,'y',144)
;  dim_z=NCDF_DIMDEF(data,'z',13)
;  var_time=NCDF_VARDEF(data,'time',dim_z,/FLOAT)
;  var_lat=NCDF_VARDEF(data,'lat',dim_x,/FLOAT)
;  var_lon=NCDF_VARDEF(data,'lon',dim_y,/FLOAT)
;  var_tco=NCDF_VARDEF(data,'TCO',[dim_x,dim_y,dim_z],/FLOAT)
;  NCDF_CONTROL, data, /ENDEF
;  NCDF_VARPUT, data, var_lat, lat_array_highres
;  NCDF_VARPUT, data, var_lon, lon_array_highres
;  NCDF_VARPUT, data, var_time, time
;  NCDF_VARPUT, data, var_tco, TCO_mean79to81_Array_highres
;  NCDF_CLOSE, data

;  output_file='/volumes/Data_Thor/birgit/TCO_BS/Mean_TCO_BS_95to97_highres.nc'
;  data=NCDF_CREATE(output_file, /CLOBBER)
;  dim_x=NCDF_DIMDEF(data,'x',72)
;  dim_y=NCDF_DIMDEF(data,'y',144)
;  dim_z=NCDF_DIMDEF(data,'z',13)
;  var_time=NCDF_VARDEF(data,'time',dim_z,/FLOAT)
;  var_lat=NCDF_VARDEF(data,'lat',dim_x,/FLOAT)
;  var_lon=NCDF_VARDEF(data,'lon',dim_y,/FLOAT)
;  var_tco=NCDF_VARDEF(data,'TCO',[dim_x,dim_y,dim_z],/FLOAT)
;  NCDF_CONTROL, data, /ENDEF
;  NCDF_VARPUT, data, var_lat, lat_array_highres
;  NCDF_VARPUT, data, var_lon, lon_array_highres
;  NCDF_VARPUT, data, var_time, time
;  NCDF_VARPUT, data, var_tco, TCO_mean95to97_Array_highres
;  NCDF_CLOSE, data
;endif




end