//@***h* BDBP/gb_GeneralConstantsAndTypes.pas
// 
// NAME
//   gb_GeneralConstantsAndTypes.pas
//
// PURPOSE
//  Defines some constants and structures for use when calculating monthly mean values
//  out of the BDBP database.
//
// DESCRIPTION
//  This unit defines some constants and structures for use when calculating monthly 
//  mean values out of the BDBP database.
//  
// AUTHOR
//  Birgit Hassler, CIRES / NOAA ESRL CSD
//
// COPYRIGHT 
//   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
//   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
//   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
//   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
//   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
//   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
//   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
//   SUPPORT TO USERS.
//
// REVISION HISTORY
//   6/16/2014 Initial Version prepared for NCDC.
// 
//@***** 


unit gb_GeneralConstantsAndTypes;

{$I UNITDIREC.INC}

interface

type
  st3=string[3];
  st30=string[30];
  st40=string[40];
  st43=string[43];
  st80=string[80];
  st200=string[200];

  TResolution=(ResRandom,ResSecond,ResMinute,ResHour,ResDay,ResMonth,ResQuarterly,ResSemiAnnual,ResYear);

  TMeasRec=record
    Value,
    Weight,
    CosWeight:single;
    Ozonesonde:boolean;
  end;


implementation

end.
